local addonName, addon = ...
local L = addon.L
_G[addonName] = addon

function addon:normalize(s) 
  s = s:lower()
  s = s:gsub("%p"," ")
  s = s:gsub("%s%s+", " ")
  s = s:gsub("^%s", " ")
  s = s:gsub("%s$", " ")
  return s
end

addon.bossname = addon:normalize(L["Jandice Barov"])
addon.engage = addon:normalize(L["challenge the Mistress of Illusion"])
addon.wipe = addon:normalize(L["Better luck next time"])
addon.defeat = addon:normalize(L["Ugh... death... hurts? Unreal"])

local bt, bt2
function addon:toggle(enable)
  local cap
  if not bt then
    bt = CreateFrame("PlayerModel");
    bt:SetHeight(600);bt:SetWidth(150);
    bt:SetScript("OnEvent",function() bt:SetUnit("target") end);
    bt2 = CreateFrame("PlayerModel");
    bt2:SetHeight(600);bt2:SetWidth(150);
    bt:SetPoint("BOTTOMRIGHT",bt2,"BOTTOMLEFT",0,0);
    bt2:SetPoint("RIGHT",nil,"RIGHT",-100,0);
    bt:Hide()
  end
  if UnitExists("boss1") and addon:normalize(UnitName("boss1")) == addon.bossname then
    bt2:SetUnit("boss1")
    cap = true
  elseif UnitExists("target") and addon:normalize(UnitName("target")) == addon.bossname then
    bt2:SetUnit("target")
    cap = true
  end
  if enable == nil then
     enable = not bt:IsShown()
  end
  if enable then
    bt:RegisterEvent("PLAYER_TARGET_CHANGED");
    bt:SetUnit("target")
    bt:Show()
    bt2:Show()
  else
    bt:UnregisterEvent("PLAYER_TARGET_CHANGED")
    bt:Hide()
    bt2:Hide()
  end
  return cap
end
SLASH_BarovHelper1 = "/barov"
SlashCmdList.BarovHelper = function(arg) 
  local enable
  if arg and #arg > 0 then 
    arg = arg:lower()
    if arg == "on" or arg == "yes" or (tonumber(arg) or 0) > 0 then
       enable = true
    else
       enable = false
    end
  end
  addon:toggle(enable) 
end
local evtframe = CreateFrame("Frame")
for _,evt in pairs({"CHAT_MSG_MONSTER_YELL","CHAT_MSG_MONSTER_SAY","CHAT_MSG_MONSTER_EMOTE","CHAT_MSG_MONSTER_PARTY"}) do
  evtframe:RegisterEvent(evt)
end
local updateelap = 10
local function refresh(f,elap)
  updateelap = updateelap + elap
  if updateelap > 0.25 then
    updateelap = 0
    if addon:toggle(true) then
        print(addonName..": activated.")
        evtframe:SetScript("OnUpdate", nil)
    end
  end
end
evtframe:SetScript("OnEvent", function(f,evt,msg) 
  msg = addon:normalize(msg or "")
  if msg:find(addon.engage,1,true) then
    evtframe:SetScript("OnUpdate", refresh)
  elseif msg:find(addon.wipe,1,true) or msg:find(addon.defeat,1,true) then
    addon:toggle(false)
    evtframe:SetScript("OnUpdate", nil)
  end
end)

